# Проект "Ночные скрипты"

По мере развития любого проекта необходимо заботиться о состоянии развернутого приложения в проде. Должны выполняться 
такие задачи, как:

- Очистка устаревших файлов;
- Зачистка служебных записей по истечении времени хранения;
- Иные служебные задачи.

Данный пакет предоставляет довольно простую функцию - запуск Django-команд помеченных атрибутом `nightly_script = True`.
В основе лежит команда `execute_nightly_scripts`, которая осуществляет запуск ночных скриптов. Данная команда должна 
запускаться по cron-у или другим аналогичным средством.

## Требования к окружению

Для работы требуется Python >=3.9. Так же в зависимостях есть пакеты:

- Django>=3.2.

Версии всех пакетов уточнены в файлах с зависимостями.

## Параметры конфигурационного файла

В разных проектах существуют различные способы добавления настроек, где-то через плагины, где-то напрямую в settings.py.
Будет рассмотрен подход указания настроек в settings.py и указания параметров в конфигурационном файле.

Для возможности конфигурирования необходимо проделать ряд действий:

- Добавить пакет `nightly_scripts` в INSTALLED_APPS в settings.py:
    ```
    INSTALLED_APPS = (
        <some_app>,
        ...,
        'nightly_scripts',
    )
    ```

## Сборка и распространение

Сборка пакета производится при помощи [Job-а в Jenkins M3.build_dist](http://jenkins.py.bars.group/view/PY/job/M3.packages/job/M3.build_dist/).

Пакет выкладывается в глобальный [PYPI](https://pypi.org/project/edu-rdm-integration/) и во внутренний [Nexus](http://nexus.py.bars.group/#browse/browse:pypi-edu-private:edu-rdm-integration) 

## Документация

С документацией можно ознакомиться по ссылке http://docs.py.bars.group/nigtly-scripts/
